 #include "config.h"

char string[] = "                ";

void main(void)
{
    set_bit( osccon, IRCF2 );           //8 MHz
    set_bit( osccon, IRCF1);
    set_bit( osccon, IRCF0 );

	trisb=0;
    trisa=0;
    porta=0;

	while(1){

        show_7(0x0E,0x11,0x13,0x15,0x19,0x11,0x0E,1); //#0
        show_7(0x04,0x0c,0x14,0x04,0x04,0x04,0x1F,1); //1
        show_7(0x0e,0x11,0x01,0x0e,0x10,0x10,0x1F,1); //#2
        show_7(0x0e,0x11,0x01,0x06,0x01,0x11,0x0e,1); //#3
        show_7(0x02,0x06,0x0A,0x12,0x1F,0x02,0x02,1); //#4
        show_7(0x1f,0x10,0x10,0x1e,0x01,0x11,0x0e,1); //#5
        show_7(0x0e,0x11,0x10,0x1e,0x11,0x11,0x0e,1); //#6
        show_7(0x1e,0x01,0x02,0x04,0x08,0x08,0x08,1); //#7
        show_7(0x0e,0x11,0x11,0x0e,0x11,0x11,0x0e,1); //#8
        show_7(0x0e,0x11,0x11,0x0f,0x01,0x11,0x0e,1); //#9
	}
}

void show_7(unsigned char r1,unsigned char r2,unsigned char r3,unsigned char r4,unsigned char r5,unsigned char r6,unsigned char r7, bit scroll)
{
    int z;
    int y;
    int x;

    for(x=5;x>0;x--){
        for(z=0;z<2;z++){
            for(y=0;y<88;y++){
               led_nybble(r1>>x, 0b0000001); // Row 1
               led_nybble(r2>>x, 0b0000010); // Row 2
               led_nybble(r3>>x, 0b0000100); // Row 3
               led_nybble(r4>>x, 0b0001000); // Row 4
               led_nybble(r5>>x, 0b0010000); // Row 5
               led_nybble(r6>>x, 0b0100000); // Row 6
               led_nybble(r7>>x, 0b1000000); // Row 7
            }
            if(scroll==1)
                break;
        }
        
        if(scroll==0)
            break;
    }

    for(x=0;x<5;x++){
        for(z=0;z<2;z++){
            for(y=0;y<88;y++){
               led_nybble(r1<<x, 0b0000001); // Row 1
               led_nybble(r2<<x, 0b0000010); // Row 2
               led_nybble(r3<<x, 0b0000100); // Row 3
               led_nybble(r4<<x, 0b0001000); // Row 4
               led_nybble(r5<<x, 0b0010000); // Row 5
               led_nybble(r6<<x, 0b0100000); // Row 6
               led_nybble(r7<<x, 0b1000000); // Row 7
            }
            if(scroll==1)
                break;
        }
        
        if(scroll==0)
            break;
    }
}

void led_nybble(unsigned char nyb, unsigned char row)
{
	int i;
	data=0;							//clear the 174
	for(i=0;i<12;i++){				//repeat for 6 bits
		clock=1;clock=0;			//write 0's to the 174
	}


	for(i=0;i<5;i++){				//output the nybbles
		if((nyb & 0x01) != 0)
			data=1;
		else
			data=0;
		clock=1;clock=0;
		nyb=nyb>>1;
	}

	for(i=0;i<7;i++){				//output the nybbles
		if((row & 0x40) != 0)
			data=1;
		else
			data=0;
		clock=1;clock=0;
		row=row<<1;
	}

    delay_ms(1);
}
 
void led_nybble2(unsigned char nyb2, unsigned char row2)
{
    int y;
        led_nybble(nyb2, row2);
 
}